package com.tongda.tdpimssdk.http;

import com.tongda.tdpimssdk.auth.SaAuth;
import org.apache.http.Header;
import org.apache.http.HeaderElement;
import org.apache.http.HttpEntity;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;

import java.io.IOException;
import java.net.URISyntaxException;
import java.util.Arrays;
import java.util.HashMap;

public class PimHttpUtil {

    public static String loginGet(String url ,String user ,String password){
        try {
        //创建httpClient实例
        CloseableHttpClient client = HttpClients.createDefault();
        //创建一个uri对象
        URIBuilder uriBuilder = null;
        uriBuilder = new URIBuilder(url);

        //塞入form参数
        uriBuilder.addParameter("name", user);
        uriBuilder.addParameter("pwd", password);
        //创建httpGet远程连接实例,这里传入目标的网络地址

        HttpGet httpGet = new HttpGet(uriBuilder.build());
        // 设置请求头信息，鉴权(没有可忽略)
//        httpGet.setHeader("Authorization", "Bearer da3efcbf-0845-4fe3-8aba-ee040be542c0");
        // 设置配置请求参数(没有可忽略)
        RequestConfig requestConfig = RequestConfig.custom().setConnectTimeout(3000)// 连接主机服务超时时间
                    .setConnectionRequestTimeout(10000)// 请求超时时间
                    .setSocketTimeout(60000)// 数据读取超时时间
                    .build();
        // 为httpGet实例设置配置
        httpGet.setConfig(requestConfig);
        //执行请求
        CloseableHttpResponse response = client.execute(httpGet);
        Header [] headers=response.getHeaders("Set-Cookie");
        String satoken="";
        for (Header header:headers){
            if (header.getName().equals("Set-Cookie")){
                for(HeaderElement headerElement:header.getElements()){
                    if (headerElement.getName().equals("satoken"))
                        satoken=headerElement.getValue();
                }
            }
        }
        //获取Response状态码
        int statusCode = response.getStatusLine().getStatusCode();
        System.out.println(statusCode);
        //获取响应实体, 响应内容
        HttpEntity entity = response.getEntity();
        //通过EntityUtils中的toString方法将结果转换为字符串
        String str = EntityUtils.toString(entity);
        System.out.println(str);
        response.close();
        client.close();

        return satoken;

        } catch (URISyntaxException e) {
            throw new RuntimeException(e);
        } catch (ClientProtocolException e) {
            throw new RuntimeException(e);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public static String sendGet(String url){
        try {
            //创建httpClient实例
            CloseableHttpClient client = HttpClients.createDefault();
            //创建一个uri对象
            URIBuilder uriBuilder = null;
            uriBuilder = new URIBuilder(url);

            //塞入form参数
//            uriBuilder.addParameter("name", user);
//            uriBuilder.addParameter("pwd", password);
            //创建httpGet远程连接实例,这里传入目标的网络地址

            HttpGet httpGet = new HttpGet(uriBuilder.build());
            httpGet.setHeader("Satoken", SaAuth.satoken);
            // 设置请求头信息，鉴权(没有可忽略)
//        httpGet.setHeader("Authorization", "Bearer da3efcbf-0845-4fe3-8aba-ee040be542c0");
            // 设置配置请求参数(没有可忽略)
            RequestConfig requestConfig = RequestConfig.custom().setConnectTimeout(60000)// 连接主机服务超时时间
                    .setConnectionRequestTimeout(60000)// 请求超时时间
                    .setSocketTimeout(60000)// 数据读取超时时间
                    .build();
            // 为httpGet实例设置配置
            httpGet.setConfig(requestConfig);
            //执行请求
            CloseableHttpResponse response = client.execute(httpGet);
            //获取Response状态码
            int statusCode = response.getStatusLine().getStatusCode();
            System.out.println(statusCode);
            //获取响应实体, 响应内容
            HttpEntity entity = response.getEntity();
            //通过EntityUtils中的toString方法将结果转换为字符串
            String str = EntityUtils.toString(entity);
            System.out.println(str);
            response.close();
            client.close();

            return str;

        } catch (URISyntaxException e) {
            throw new RuntimeException(e);
        } catch (ClientProtocolException e) {
            throw new RuntimeException(e);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public static String sendPost(String url , HashMap hashMap,String satoken){
        try {
            //创建httpClient实例
            CloseableHttpClient client = HttpClients.createDefault();
            //创建一个uri对象
            URIBuilder uriBuilder = null;
            uriBuilder = new URIBuilder(url);

            //塞入form参数
//            uriBuilder.addParameter("name", user);
//            uriBuilder.addParameter("pwd", password);
            //创建httpGet远程连接实例,这里传入目标的网络地址

            HttpGet httpGet = new HttpGet(uriBuilder.build());
            httpGet.setHeader("Satoken",satoken);
            // 设置请求头信息，鉴权(没有可忽略)
//        httpGet.setHeader("Authorization", "Bearer da3efcbf-0845-4fe3-8aba-ee040be542c0");
            // 设置配置请求参数(没有可忽略)
            RequestConfig requestConfig = RequestConfig.custom().setConnectTimeout(10000)// 连接主机服务超时时间
                    .setConnectionRequestTimeout(10000)// 请求超时时间
                    .setSocketTimeout(60000)// 数据读取超时时间
                    .build();
            // 为httpGet实例设置配置
            httpGet.setConfig(requestConfig);
            //执行请求
            CloseableHttpResponse response = client.execute(httpGet);
            //获取Response状态码
            int statusCode = response.getStatusLine().getStatusCode();
            System.out.println(statusCode);
            //获取响应实体, 响应内容
            HttpEntity entity = response.getEntity();
            //通过EntityUtils中的toString方法将结果转换为字符串
            String str = EntityUtils.toString(entity);
            System.out.println(str);
            response.close();
            client.close();

            return "";

        } catch (URISyntaxException e) {
            throw new RuntimeException(e);
        } catch (ClientProtocolException e) {
            throw new RuntimeException(e);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
